/* 
 * Eneso Single Program Instance Library
 * Eneso Tecnología de Adaptación, S.L. 
 */

#include <windows.h>
#include "esingle.h"

static HWND single_window = NULL;

static ESingleInstanceCb	user_instance_cb = NULL;

static LRESULT CALLBACK
single_wnd_proc	(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);


	int
esingle_init (const char* name, ESingleInstanceCb instance_cb)
{
	WNDCLASSW	wc;
	HWND		hwnd;

	user_instance_cb = instance_cb;

	hwnd = FindWindowW ((LPCWSTR) name, (LPCWSTR) name);

	if (!hwnd)
	{
		memset (&wc, 0, sizeof (wc));

		wc.hInstance   		= GetModuleHandle (NULL);
		wc.lpfnWndProc  	= single_wnd_proc;
		wc.lpszClassName	= (LPCWSTR) name;

		RegisterClassW (&wc);

		single_window = CreateWindowExW (0, (LPCWSTR) name, (LPCWSTR) name,
				WS_POPUP, 0, 0, 1, 1, NULL, NULL, wc.hInstance, NULL);	

		return TRUE;
	}
	else 
	{
		SendMessage (hwnd, 0, 0, 0); 

		return FALSE;
	}
}

	void
esingle_terminate (void)
{
	single_window = NULL;

	DestroyWindow (single_window);
}

	static LRESULT CALLBACK
single_wnd_proc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if (uMsg == 0)
	{
		if (user_instance_cb)
			user_instance_cb ();
	}

	return DefWindowProcW (hWnd, uMsg, wParam, lParam);
}
